groups:
  - name: IPFS Configuration
    description: Configure IPFS
  - name: User and Group Configuration
    description: Configure User and Group for IPFS
  - name: Network Configuration
    description: Configure Network for IPFS
  - name: Storage Configuration
    description: Configure Storage for IPFS
  - name: Resources Configuration
    description: Configure Resources for IPFS

portals:
  web_portal:
    protocols:
      - "$kubernetes-resource_configmap_portal_protocol"
    host:
      - "$kubernetes-resource_configmap_portal_host"
    ports:
      - "$kubernetes-resource_configmap_portal_port"
    path: "$kubernetes-resource_configmap_portal_path"

questions:

  - variable: ipfsConfig
    label: ""
    group: IPFS Configuration
    schema:
      type: dict
      attrs:
        - variable: additionalEnvs
          label: Additional Environment Variables
          description: Configure additional environment variables for IPFS.
          schema:
            type: list
            default: []
            items:
              - variable: env
                label: Environment Variable
                schema:
                  type: dict
                  attrs:
                    - variable: name
                      label: Name
                      schema:
                        type: string
                        required: true
                    - variable: value
                      label: Value
                      schema:
                        type: string
                        required: true

  - variable: ipfsRunAs
    label: ""
    group: User and Group Configuration
    schema:
      type: dict
      attrs:
        - variable: user
          label: User ID
          description: The user id that IPFS will run as.
          schema:
            type: int
            min: 1
            default: 568
            required: true
        - variable: group
          label: Group ID
          description: The group id that IPFS will run as.
          schema:
            type: int
            min: 1
            default: 568
            required: true

  - variable: ipfsNetwork
    label: ""
    group: Network Configuration
    schema:
      type: dict
      attrs:
        - variable: apiPort
          label: API Port
          description: The port for the IPFS API (And WebUI).
          schema:
            type: int
            default: 30000
            min: 9000
            max: 65535
            required: true
        - variable: swarmPort
          label: Swarm Port
          description: The port for the IPFS Swarm. Both TCP and UDP
          schema:
            type: int
            default: 30001
            min: 9000
            max: 65535
            required: true
        - variable: gatewayPort
          label: Gateway Port
          description: The port for the IPFS Gateway.
          schema:
            type: int
            default: 30002
            min: 9000
            max: 65535
            required: true
        - variable: hostNetwork
          label: Host Network
          description: |
            Bind to the host network. It's recommended to keep this disabled.
          schema:
            type: boolean
            default: false

  - variable: ipfsStorage
    label: ""
    group: Storage Configuration
    schema:
      type: dict
      attrs:
        - variable: data
          label: IPFS Data Storage
          description: The path to store IPFS data.
          schema:
            type: dict
            attrs:
              - variable: type
                label: Type
                description: |
                  ixVolume: Is dataset created automatically by the system.</br>
                  Host Path: Is a path that already exists on the system.
                schema:
                  type: string
                  required: true
                  default: ixVolume
                  enum:
                    - value: hostPath
                      description: Host Path (Path that already exists on the system)
                    - value: ixVolume
                      description: ixVolume (Dataset created automatically by the system)
              - variable: datasetName
                label: Dataset Name
                schema:
                  type: string
                  show_if: [["type", "=", "ixVolume"]]
                  required: true
                  hidden: true
                  immutable: true
                  default: data
                  $ref:
                    - "normalize/ixVolume"
              - variable: hostPath
                label: Host Path
                schema:
                  type: hostpath
                  show_if: [["type", "=", "hostPath"]]
                  immutable: true
                  required: true
        - variable: staging
          label: IPFS Staging Storage
          description: The path to store IPFS staging storage.
          schema:
            type: dict
            attrs:
              - variable: type
                label: Type
                description: |
                  ixVolume: Is dataset created automatically by the system.</br>
                  Host Path: Is a path that already exists on the system.
                schema:
                  type: string
                  required: true
                  default: ixVolume
                  enum:
                    - value: hostPath
                      description: Host Path (Path that already exists on the system)
                    - value: ixVolume
                      description: ixVolume (Dataset created automatically by the system)
              - variable: datasetName
                label: Dataset Name
                schema:
                  type: string
                  show_if: [["type", "=", "ixVolume"]]
                  required: true
                  hidden: true
                  immutable: true
                  default: staging
                  $ref:
                    - "normalize/ixVolume"
              - variable: hostPath
                label: Host Path
                schema:
                  type: hostpath
                  show_if: [["type", "=", "hostPath"]]
                  immutable: true
                  required: true

  - variable: resources
    label: ""
    group: Resources Configuration
    schema:
      type: dict
      attrs:
        - variable: limits
          label: Limits
          schema:
            type: dict
            attrs:
              - variable: cpu
                label: CPU
                description: CPU limit for IPFS.
                schema:
                  type: string
                  default: 4000m
                  required: true
              - variable: memory
                label: Memory
                description: Memory limit for IPFS.
                schema:
                  type: string
                  default: 8Gi
                  required: true
